verify-generated-runtime.sh 1.5 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546
  1. #!/usr/bin/env bash
  2. # Copyright 2016 The Kubernetes Authors.
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. set -o errexit
  16. set -o nounset
  17. set -o pipefail
  18. KUBE_ROOT=$(dirname "${BASH_SOURCE[0]}")/..
  19. KUBE_REMOTE_RUNTIME_ROOT="${KUBE_ROOT}/staging/src/k8s.io/cri-api/pkg/apis/runtime/v1alpha2"
  20. source "${KUBE_ROOT}/hack/lib/init.sh"
  21. kube::golang::setup_env
  22. function cleanup {
  23. rm -rf "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp/"
  24. }
  25. trap cleanup EXIT
  26. mkdir -p "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp"
  27. cp "${KUBE_REMOTE_RUNTIME_ROOT}/api.pb.go" "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp/"
  28. ret=0
  29. KUBE_VERBOSE=3 "${KUBE_ROOT}/hack/update-generated-runtime.sh"
  30. diff -I "gzipped FileDescriptorProto" -I "0x" -Naupr "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp/api.pb.go" "${KUBE_REMOTE_RUNTIME_ROOT}/api.pb.go" || ret=$?
  31. if [[ $ret -eq 0 ]]; then
  32. echo "Generated container runtime api is up to date."
  33. cp "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp/api.pb.go" "${KUBE_REMOTE_RUNTIME_ROOT}/"
  34. else
  35. echo "Generated container runtime api is out of date. Please run hack/update-generated-runtime.sh"
  36. exit 1
  37. fi